/*
 * Ghalya Alsanea
 */

#include"pitches.h"

// notes in the song 'Mukkathe Penne'
int melody[] = {
NOTE_D4, NOTE_G4, NOTE_FS4, NOTE_A4,
NOTE_G4, NOTE_C5, NOTE_AS4, NOTE_A4,                   
NOTE_FS4, NOTE_G4, NOTE_A4, NOTE_FS4, NOTE_DS4, NOTE_D4,
NOTE_C4, NOTE_D4,0,                                 

NOTE_D4, NOTE_G4, NOTE_FS4, NOTE_A4,
NOTE_G4, NOTE_C5, NOTE_D5, NOTE_C5, NOTE_AS4, NOTE_C5, NOTE_AS4, NOTE_A4,      //29               //8
NOTE_FS4, NOTE_G4, NOTE_A4, NOTE_FS4, NOTE_DS4, NOTE_D4,
NOTE_C4, NOTE_D4,0,                                       

NOTE_D4, NOTE_FS4, NOTE_G4, NOTE_A4, NOTE_DS5, NOTE_D5,
NOTE_C5, NOTE_AS4, NOTE_A4, NOTE_C5,
NOTE_C4, NOTE_D4, NOTE_DS4, NOTE_FS4, NOTE_D5, NOTE_C5,
NOTE_AS4, NOTE_A4, NOTE_C5, NOTE_AS4,             //58

NOTE_D4, NOTE_FS4, NOTE_G4, NOTE_A4, NOTE_DS5, NOTE_D5,
NOTE_C5, NOTE_D5, NOTE_C5, NOTE_AS4, NOTE_C5, NOTE_AS4, NOTE_A4, NOTE_C5, NOTE_G4,
NOTE_A4, 0, NOTE_AS4, NOTE_A4, 0, NOTE_G4,
NOTE_G4, NOTE_A4, NOTE_G4, NOTE_FS4, 0,

NOTE_C4, NOTE_D4, NOTE_G4, NOTE_FS4, NOTE_DS4,
NOTE_C4, NOTE_D4, 0,
NOTE_C4, NOTE_D4, NOTE_G4, NOTE_FS4, NOTE_DS4,
NOTE_C4, NOTE_D4, 0

};

// note durations: 8 = quarter note, 4 = 8th note, etc.
int noteDurations[] = {       //duration of the notes
8,4,8,4,
4,4,4,12,
4,4,4,4,4,4,
4,16,4,

8,4,8,4,
4,2,1,1,2,1,1,12,
4,4,4,4,4,4,
4,16,4,

4,4,4,4,4,4,
4,4,4,12,
4,4,4,4,4,4,
4,4,4,12,

4,4,4,4,4,4,
2,1,1,2,1,1,4,8,4,
2,6,4,2,6,4,
2,1,1,16,4,

4,8,4,4,4,
4,16,4,
4,8,4,4,4,
4,20,
};

int speakerSpeed = 90;  //higher value, slower notes

const int speakerPin = 9;
const int buzzer = 10;
const int interruptPin = 3;
const int potPin = A0;     //potentiometer
 
int speakerState = LOW; 
int potValue = 0;           //pot values

int buzzFreq = 500;
int buzzDelay = 100;


void setup() {
  Serial.begin(9600);
  pinMode(speakerPin, OUTPUT);
  pinMode(buzzer, OUTPUT);
  pinMode(interruptPin, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(interruptPin), changeMe, CHANGE);
}

void loop() {
//  speakerState = digitalRead(speakerPin);
  
  if (speakerState == LOW) {
    for (int thisNote = 0; melody[thisNote] != -1; thisNote++) {
      potValue = analogRead(potPin);
      speakerSpeed = map(potValue, 0, 1023, 50, 120);
      int noteDuration = speakerSpeed * noteDurations[thisNote];
      tone(speakerPin, melody[thisNote],noteDuration * 0.95);
      delay(noteDuration);
      noTone(speakerPin);
      Serial.println(speakerState);
      if (speakerState == HIGH){
        playBuzz();
      } 
    }
  }
  if(speakerState == HIGH) {
    playBuzz();
  }
}

void changeMe() {
  speakerState = !speakerState;
}

void playBuzz() {
  for (int i = 500; i < 1000; i+=10) {
    tone(buzzer, i);    // Send 1KHz sound signal...
    delay(buzzDelay);   // ...for 1 sec
    noTone(buzzer);     // Stop sound...
    delay(1000);        // ...for 1sec
    
  }
}

//future iterations...
//switch to something that plays the message
//play when you see that people have queited then say the message
